#pragma once

#include <3ds.h>
#include <cstdarg>
#include <cctype>
#include <unistd.h>
//#include "Audio.hpp"

#ifndef Sint16
#define Sint8 int8_t
#define Sint16 int16_t
#define Sint32 int32_t
#define Sint64 int64_t
#define Uint8 uint8_t
#define Uint16 uint16_t
#define Uint32 uint32_t
#define Uint64 uint64_t
#endif

enum {
	CORE_DEFAULT = -2,
	CORE_ANY = -1,
	CORE_APPLICATION = 0,
	CORE_SYSTEM = 1,
	CORE_NEW1 = 2,
	CORE_NEW2 = 3
};

//system
void n3ds_Init();
void n3ds_Exit();

bool n3ds_MainLoop();

void* n3ds_CreateThread(void (*func)(void*), void* arg, int core = CORE_DEFAULT);

int n3ds_GetLanguage();

void n3ds_Print(const char *msg, ...);
void n3ds_Warning(const char *msg, ...);

//video
void n3ds_InitGraphics();
void n3ds_ExitGraphics();

void n3ds_SetScreenWidth(int xsize);
void n3ds_CopyFrameBuffer(Uint16* pixels, bool vsync);

//audio
int n3ds_InitAudio();
void n3ds_ExitAudio();

void n3ds_LockAudio();
void n3ds_UnlockAudio();

void n3ds_SetAudioProcess(void (*proc)(void*, uint8_t*, int));

Sint16* n3ds_LoadWavMem(void* fileBuf, size_t size, size_t* len);
Sint16* n3ds_LoadOggMem(void* fileBuf, size_t size, size_t* len);

//input
void n3ds_ScanInput();
bool n3ds_GetButtonDown(int btn);